package cordova.plugin.netcontroll.integration.tef.helpers;

import android.app.Activity;
import android.content.Context;
import android.os.Handler;
import android.os.Looper;
import android.os.Message;
import android.util.Log;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ListView;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.appcompat.app.AlertDialog;

import com.elgin.e1.core.Mask;
import com.elgin.e1.core.constant.Returns;
import com.elgin.e1.core.constant.tef.TefDefines;
import com.elgin.e1.core.model.tef.EntradaTef;
import com.elgin.e1.pagamentos.tef.E1_ElginTef;
import com.elgin.e1.pagamentos.tef.ElginTef;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Timer;
import java.util.TimerTask;

public class TefElginHelper_E1ElginTef {//extends Thread {
    private final String TAG = TefElginHelper_E1ElginTef.class.getSimpleName();
    private Boolean idle;
    private String result;
    private EntradaTef tef;
    private Handler appHandler;
    private Context appContext;
    private TefElginHelper_E1ElginTef_ActionCallback actionCallBack;
    private Handler handler = new Handler(Looper.getMainLooper()) {
        public void handleMessage(@NonNull Message msg) {
            super.handleMessage(msg);
            Log.d(TefElginHelper_E1ElginTef.this.TAG, "What [" + msg.what + "]");
            Log.d(TefElginHelper_E1ElginTef.this.TAG, "Obj [" + msg.obj + "]");
            String saida = null;
            ArrayAdapter adapter = null;

            try {
                if (msg.what == TefDefines.INICIAR) {
//                    TefElginHelper_E1ElginTef.this.inflater = ((Activity)TefElginHelper_E1ElginTef.this.getAppContext()).getLayoutInflater();
//                    TefElginHelper_E1ElginTef.this.view = TefElginHelper_E1ElginTef.this.inflater.inflate(layout.transaction_api, (ViewGroup)null);
//                    TefElginHelper_E1ElginTef.this.mensagem = (TextView)TefElginHelper_E1ElginTef.this.view.findViewById(id.message_api);
//                    TefElginHelper_E1ElginTef.this.value = (EditText)TefElginHelper_E1ElginTef.this.view.findViewById(id.value_api);
//                    TefElginHelper_E1ElginTef.this.value.addTextChangedListener(Mask.valor(TefElginHelper_E1ElginTef.this.value));
//                    TefElginHelper_E1ElginTef.this.value.setOnClickListener(TefElginHelper_E1ElginTef.this.informar_valor);
//                    TefElginHelper_E1ElginTef.this.options = (ListView)TefElginHelper_E1ElginTef.this.view.findViewById(id.options_api);
//                    TefElginHelper_E1ElginTef.this.options.setOnItemClickListener(TefElginHelper_E1ElginTef.this.opcao_coleta);
//                    TefElginHelper_E1ElginTef.this.cancel = (Button)TefElginHelper_E1ElginTef.this.view.findViewById(id.cancel_api);
//                    TefElginHelper_E1ElginTef.this.cancel.setOnClickListener(TefElginHelper_E1ElginTef.this.cancelar_operacao);
//                    TefElginHelper_E1ElginTef.this.builder = new Builder(TefElginHelper_E1ElginTef.this.getAppContext());
//                    TefElginHelper_E1ElginTef.this.builder.setView(TefElginHelper_E1ElginTef.this.view);
//                    TefElginHelper_E1ElginTef.this.dialog = TefElginHelper_E1ElginTef.this.builder.create();
//                    TefElginHelper_E1ElginTef.this.dialog.setCanceledOnTouchOutside(false);
//                    TefElginHelper_E1ElginTef.this.dialog.setCancelable(false);
//                    TefElginHelper_E1ElginTef.this.dialog.show();
                    sendActionMessageCallback("INICIANDO");
                } else if (msg.what == TefDefines.MENSAGEM) {
                    saida = ElginTef.ObterMensagemProgresso();
                    sendActionMessageCallback(saida.toUpperCase());
//                    TefElginHelper_E1ElginTef.this.mensagem.setText(saida.toUpperCase());
//                    TefElginHelper_E1ElginTef.this.cancel.setVisibility(0);
//                    TefElginHelper_E1ElginTef.this.options.setVisibility(8);
//                    TefElginHelper_E1ElginTef.this.value.setVisibility(8);
                } else if (msg.what == TefDefines.OPCAO_COLETA) {
                    saida = ElginTef.ObterOpcaoColeta();
//                    List<String> listaOpcoes = TefElginHelper_E1ElginTef.this.tratarOpcaoColeta(saida);
//                    sendActionCollectDataCallback(listaOpcoes);
                    sendActionMessageCallback(saida.toUpperCase());
//                    adapter = new ArrayAdapter(TefElginHelper_E1ElginTef.this.getAppContext(), 17367043, TefElginHelper_E1ElginTef.this.tratarOpcaoColeta(saida));
//                    TefElginHelper_E1ElginTef.this.mensagem.setText("SELECIONE UMA OPÇÃO:");
//                    TefElginHelper_E1ElginTef.this.options.setAdapter(adapter);
//                    TefElginHelper_E1ElginTef.this.options.setVisibility(0);
//                    TefElginHelper_E1ElginTef.this.value.setVisibility(8);
                } else if (msg.what == TefDefines.INFORMAR_VALOR) {
                    saida = ElginTef.ObterMensagemProgresso();
//                    sendActionCollectDataValorCallback(saida.toUpperCase());
                    sendActionMessageCallback(saida.toUpperCase());
//                    TefElginHelper_E1ElginTef.this.mensagem.setText(saida.toUpperCase());
//                    TefElginHelper_E1ElginTef.this.value.setVisibility(0);
//                    TefElginHelper_E1ElginTef.this.cancel.setVisibility(0);
//                    TefElginHelper_E1ElginTef.this.options.setVisibility(8);
                } else if (msg.what == TefDefines.DADOS_TRANSACAO) {
                    TefElginHelper_E1ElginTef.this.result = ElginTef.ObterDadosTransacao();
                } else if (msg.what == TefDefines.FINALIZAR) {
                    saida = ElginTef.ObterMensagemProgresso();
                    sendActionMessageCallback(saida.toUpperCase());
//                    TefElginHelper_E1ElginTef.this.mensagem.setText(saida.toUpperCase());
//                    TefElginHelper_E1ElginTef.this.options.setVisibility(8);
//                    TefElginHelper_E1ElginTef.this.value.setVisibility(8);
//                    TefElginHelper_E1ElginTef.this.cancel.setVisibility(8);
//                    TefElginHelper_E1ElginTef.this.aguardarFinalizacao();
                    String saidaSleep = saida;
                    if (TefElginHelper_E1ElginTef.this.result == null) {
                        TefElginHelper_E1ElginTef.this.finalizarTransacao(saidaSleep, Returns.ERROR);
                    } else {
                        TefElginHelper_E1ElginTef.this.finalizarTransacao(TefElginHelper_E1ElginTef.this.result, Returns.SUCCESS);
                    }
//                    (new Timer()).schedule(new TimerTask() {
//                        public void run() {
//                            if (TefElginHelper_E1ElginTef.this.result == null) {
//                                TefElginHelper_E1ElginTef.this.finalizarTransacao(saidaSleep, Returns.ERROR);
//                            } else {
//                                TefElginHelper_E1ElginTef.this.finalizarTransacao(TefElginHelper_E1ElginTef.this.result, Returns.SUCCESS);
//                            }
//                        }
//                    }, 1500L);
                } else {
                    sendActionMessageCallback("Estado indefinido");
//                    TefElginHelper_E1ElginTef.this.mensagem.setText("Estado indefinido");
//                    TefElginHelper_E1ElginTef.this.cancel.setVisibility(8);
                    TefElginHelper_E1ElginTef.this.aguardarFinalizacao();
                    TefElginHelper_E1ElginTef.this.finalizarTransacao("Erro desconhecido", Returns.ERROR);
                }
            } catch (Exception var5) {
                TefElginHelper_E1ElginTef.this.finalizarTransacao(var5.getMessage(), Returns.ERROR);
            }

        }
    };
    //    private View view;
    private Button cancel;
    private EditText value;
    private ListView options;
    private TextView mensagem;
    private AlertDialog dialog;

    private void setIdle(Boolean idle) {
        this.idle = idle;
    }

    private Boolean getIdle() {
        return this.idle;
    }

    private void setAppHandler(Handler appHandler) {
        this.appHandler = appHandler;
    }

    private Handler getAppHandler() {
        return this.appHandler;
    }

    private void setAppContext(Context appContext) {
        this.appContext = appContext;
    }

    private Context getAppContext() {
        return this.appContext;
    }

    private void aguardarFinalizacao() {
        (new Timer()).schedule(new TimerTask() {
            public void run() {
//                TefElginHelper_E1ElginTef.this.dialog.dismiss();
            }
        }, 1500L);
    }

    private List<String> tratarOpcaoColeta(String opcaoColeta) {
        ArrayList list = null;

        try {
            if (opcaoColeta == null) {
                return null;
            } else {
                list = new ArrayList(Arrays.asList(opcaoColeta.split("\n")));
                return list;
            }
        } catch (Exception var4) {
            Log.e(this.TAG, "tratarOpcaoColeta(" + var4.getMessage() + ")");
            throw var4;
        }
    }

    private String tratarValor(String valorTransacao) {
        String fim = null;
        String valor = null;
        String inicio = null;
        Integer lenght = valorTransacao.length();
        String var6 = "^[0-9]*\\.[0-9][0-9]$";

        try {
            if (valorTransacao.matches("^[0-9]*\\.[0-9][0-9]$")) {
                return valorTransacao;
            } else {
                inicio = valorTransacao.substring(0, lenght - 2);
                fim = valorTransacao.substring(lenght - 2, lenght);
                valor = String.format("%s.%s", inicio, fim);
                return valor;
            }
        } catch (Exception var8) {
            Log.e(this.TAG, "tratarValor(" + var8.getMessage() + ")");
            throw var8;
        }
    }

    private void iniciarTransacao() throws Exception {
        if (this.getIdle()) {
            this.setIdle(false);
//            this.start();
            this.run();
        } else {
            throw new Exception("Thread em execução");
        }
    }


    public void realizarCancelamentoOperacao() throws Exception {
        try {
            ElginTef.RealizarCancelamentoOperacao();
        } catch (Exception var3) {
            this.finalizarTransacao(var3.getMessage(), Returns.ERROR);
        }
    }

    public void informarValorTransacao(String valor) {
        try {
            if (valor.isEmpty()) {
                throw new Exception("Valor para transação não informado");
            }
            valor = valor.replace(",", ".");
            ElginTef.InformarOpcaoColeta(valor);
        } catch (Exception var4) {
            this.finalizarTransacao(var4.getMessage(), Returns.ERROR);
        }

    }

    ;

    private void finalizarTransacao(String data, int value) {
        Message message = new Message();
        message.obj = data;
        message.what = value;
        this.getAppHandler().sendMessage(message);
        this.setIdle(true);
        this.result = null;
    }

    public TefElginHelper_E1ElginTef(Context appContext) {
        this.setIdle(true);
        this.setAppContext(appContext);
        ElginTef.setContext(appContext);
    }

    public void run() {
        new Thread(() -> {

//        super.run();

            try {
                ElginTef.setHandler(this.handler);
                String var1 = this.tef.getTransacao();
                byte var2 = -1;
                switch (var1.hashCode()) {
                    case -1407566639:
                        if (var1.equals("ativar")) {
                            var2 = 0;
                        }
                        break;
                    case -1335752445:
                        if (var1.equals("debito")) {
                            var2 = 2;
                        }
                        break;
                    case -820075502:
                        if (var1.equals("vender")) {
                            var2 = 1;
                        }
                        break;
                    case -123173845:
                        if (var1.equals("cancelar")) {
                            var2 = 4;
                        }
                        break;
                    case -7468331:
                        if (var1.equals("relatorio")) {
                            var2 = 5;
                        }
                        break;
                    case 783117222:
                        if (var1.equals("reimprimir")) {
                            var2 = 6;
                        }
                        break;
                    case 1028633750:
                        if (var1.equals("credito")) {
                            var2 = 3;
                        }
                }

                switch (var2) {
                    case 0:
                        ElginTef.AtivarTerminal(this.tef.getDocumento());
                        break;
                    case 1:
                        ElginTef.RealizarTransacao();
                        break;
                    case 2:
                        ElginTef.RealizarTransacaoDebito(this.tef.getValorTransacao());
                        break;
                    case 3:
                        String parcelas = String.valueOf(this.tef.getNumeroParcelas());
                        ElginTef.RealizarTransacaoCredito(this.tef.getValorTransacao(), this.tef.getTipoFinanciamento(), parcelas);
                        break;
                    case 4:
                        ElginTef.RealizarCancelamentoTransacao(this.tef.getValorTransacao(), this.tef.getNsu(), this.tef.getData());
                        break;
                    case 5:
                        ElginTef.ImprimirRelatorioDiario();
                        break;
                    case 6:
                        ElginTef.ReimprimirUltimoComprovante();
                        break;
                    default:
                        this.handler.sendEmptyMessage(Returns.ERROR);
                }
            } catch (Exception var4) {
                this.finalizarTransacao(var4.getMessage(), Returns.ERROR);
            }
        }).start();
    }

    public boolean informarDadosAutomacao(String acNome, String acVersao, String acTextoPinPad, String acMacPinPad, String acProducao) throws Exception {
        ElginTef.InformarDadosAutomacao(acNome, acVersao, acTextoPinPad, acMacPinPad);
        return true;
    }

    public void ativarTerminal(String cnpjCpf, Handler appHandler, TefElginHelper_E1ElginTef_ActionCallback actionCallBack) throws Exception {
        this.setActionMessageCallback(actionCallBack);
        this.setAppHandler(appHandler);
        this.tef = new EntradaTef();
        this.tef.setDocumento(cnpjCpf);
        this.tef.setTransacao("ativar");
        this.handler.sendEmptyMessage(TefDefines.INICIAR);
        this.iniciarTransacao();
    }

    public void iniciarVenda(Handler appHandler, TefElginHelper_E1ElginTef_ActionCallback actionCallBack) throws Exception {
        this.setActionMessageCallback(actionCallBack);
        this.setAppHandler(appHandler);
        this.tef = new EntradaTef();
        this.tef.setTransacao("vender");
        this.handler.sendEmptyMessage(TefDefines.INICIAR);
        this.iniciarTransacao();
    }

    public void iniciarVendaDebito(String valorTransacao, Handler appHandler, TefElginHelper_E1ElginTef_ActionCallback actionCallBack) throws Exception {
        this.setActionMessageCallback(actionCallBack);
        this.setAppHandler(appHandler);
        String valor = this.tratarValor(valorTransacao);
        this.tef = new EntradaTef();
        this.tef.setValorTransacao(valor);
        this.tef.setTransacao("debito");
        this.handler.sendEmptyMessage(TefDefines.INICIAR);
        this.iniciarTransacao();
    }

    public void iniciarVendaCredito(String valorTransacao, int parcelas, int financiamento, Handler appHandler, TefElginHelper_E1ElginTef_ActionCallback actionCallBack) throws Exception {
        this.setActionMessageCallback(actionCallBack);
        this.setAppHandler(appHandler);
        String valor = this.tratarValor(valorTransacao);
        String tipoFinanciamento = String.valueOf(financiamento);
        this.tef = new EntradaTef();
        this.tef.setValorTransacao(valor);
        this.tef.setNumeroParcelas(parcelas);
        this.tef.setTipoFinanciamento(tipoFinanciamento);
        this.tef.setTransacao("credito");
        this.handler.sendEmptyMessage(TefDefines.INICIAR);
        this.iniciarTransacao();
    }

    public void iniciarCancelamento(String valorTransacao, String nsu, String data, Handler appHandler, TefElginHelper_E1ElginTef_ActionCallback actionCallBack) throws Exception {
        this.setActionMessageCallback(actionCallBack);
        this.setAppHandler(appHandler);
        String valor = this.tratarValor(valorTransacao);
        this.tef = new EntradaTef();
        this.tef.setNsu(nsu);
        this.tef.setData(data);
        this.tef.setValorTransacao(valor);
        this.tef.setTransacao("cancelar");
        this.handler.sendEmptyMessage(TefDefines.INICIAR);
        this.iniciarTransacao();
    }

    public void iniciarReimpressaoComprovante(Handler appHandler, TefElginHelper_E1ElginTef_ActionCallback actionCallBack) throws Exception {
        this.setActionMessageCallback(actionCallBack);
        this.setAppHandler(appHandler);
        this.tef = new EntradaTef();
        this.tef.setTransacao("reimprimir");
        this.handler.sendEmptyMessage(TefDefines.INICIAR);
        this.iniciarTransacao();
    }

    public void gerarRelatorioDiario(Handler appHandler, TefElginHelper_E1ElginTef_ActionCallback actionCallBack) throws Exception {
        this.setActionMessageCallback(actionCallBack);
        this.setAppHandler(appHandler);
        this.tef = new EntradaTef();
        this.tef.setTransacao("relatorio");
        this.handler.sendEmptyMessage(TefDefines.INICIAR);
        this.iniciarTransacao();
    }

    public void setActionMessageCallback(TefElginHelper_E1ElginTef_ActionCallback actionCallBack) {
        this.actionCallBack = actionCallBack;
    }

    public void sendActionMessageCallback(String message) {
        this.actionCallBack.onStatusChanged(message);
    }

//    public void sendActionCollectDataCallback(List<String> options) {
//        this.actionCallBack.onCollectData(options);
//    }
//
//    public void sendActionCollectDataValorCallback(String message) {
//        this.actionCallBack.onCollectDataValor(message);
//    }

    public interface TefElginHelper_E1ElginTef_ActionCallback {
        void onStatusChanged(String message);
//        void onCollectData(List<String> options);
//        void onCollectDataValor(String message);
    }
}
